/*
 * Tencent is pleased to support the open source community by making
 * WCDB available.
 *
 * Copyright (C) 2017 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the BSD 3-Clause License (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 *       https://opensource.org/licenses/BSD-3-Clause
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import XCTest
import WCDBSwift

class StatementCreateVirtualTableTests: BaseTestCase {

    func testStatementCreateVirtualTable() {
        //Give
        let moduleArgument1 = ModuleArgument(left: "left", right: "right")
        let moduleArgument2 = ModuleArgument(with: .WCDB)

        let module1 = "module1"

        let virtualTable1 = "virtualTable1"

        //Then
        XCTAssertEqual(StatementCreateVirtualTable().statementType, StatementType.createVirtualTable)

        WINQAssertEqual(
            StatementCreateVirtualTable()
                .create(virtualTable: virtualTable1)
                .using(module: module1, arguments: moduleArgument1, moduleArgument2),
            "CREATE VIRTUAL TABLE IF NOT EXISTS virtualTable1 USING module1(left=right, tokenize=WCDB)"
        )

        WINQAssertEqual(
            StatementCreateVirtualTable()
                .create(virtualTable: virtualTable1, ifNotExists: false)
                .using(module: module1, arguments: moduleArgument1, moduleArgument2),
            "CREATE VIRTUAL TABLE virtualTable1 USING module1(left=right, tokenize=WCDB)"
        )
    }
}
